scala.reflect.macros

# Attachments

#### abstract class Attachments extends AnyRef

EXPERIMENTAL

Attachments provide a way to associate custom metadata with symbols and trees.

Along with `symbol` and `tpe`, which represent core metadata of trees, each tree carries the `attachments` field that can store other metadata: compiler-defined (e.g. positions) or user-defined. Same story is true for symbols, which also have extensible metadata by the virtue of the same `attachments` field.

Typically attachments just store a scala.reflect.api.Position, but they can be extended to encompass arbitrary payloads. Payloads are stored in type-indexed slots, which can be read with `get[T]` and written with `update[T]` and `remove[T]`.

This API doesn't have much use in the runtime reflection API (the scala.reflect.api package), but it might be of help for macro writers, providing a way to coordinate multiple macros operating on the same code. Therefore the `attachments` field is only declared in trees and symbols belonging to scala.reflect.macros.Universe.

Self Type
  Attachments
Source
  Attachments.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Position
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Attachments
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Attachments()

### Type Members

1. #### abstract type Pos >: Null

   The position type of this attachment

### Abstract Value Members

1. #### abstract def pos: Pos

   The underlying position

2. #### abstract def withPos(newPos: Pos): Attachments { type Pos = Attachments.this.Pos }

   Creates a copy of this attachment with the position replaced by `newPos`

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Attachments to any2stringadd[Attachments] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Attachments, B)

   Implicit information
     This member is added by an implicit conversion from Attachments to ArrowAssoc[Attachments] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def all: Set[Any]

   The underlying payload with the guarantee that no two elements have the same type.

7. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### def contains[T](implicit arg0: ClassTag[T]): Boolean

   Check underlying payload contains an instance of type `T`.

10. #### def ensuring(cond: (Attachments) ⇒ Boolean, msg: ⇒ Any): Attachments

    Implicit information
      This member is added by an implicit conversion from Attachments to Ensuring[Attachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (Attachments) ⇒ Boolean): Attachments

    Implicit information
      This member is added by an implicit conversion from Attachments to Ensuring[Attachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): Attachments

    Implicit information
      This member is added by an implicit conversion from Attachments to Ensuring[Attachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): Attachments

    Implicit information
      This member is added by an implicit conversion from Attachments to Ensuring[Attachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

17. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Attachments to StringFormat[Attachments] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

18. #### def get[T](implicit arg0: ClassTag[T]): Option[T]

    An underlying payload of the given class type `T`.

19. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

20. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

21. #### def isEmpty: Boolean

22. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

23. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

24. #### final def notify(): Unit

    Definition Classes
      AnyRef

25. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

26. #### def remove[T](implicit arg0: ClassTag[T]): Attachments { type Pos = Attachments.this.Pos }

    Creates a copy of this attachment with the payload of the given class type `T` removed.

27. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

28. #### def toString(): String

    Definition Classes
      AnyRef → Any

29. #### def update[T](attachment: T)(implicit arg0: ClassTag[T]): Attachments { type Pos = Attachments.this.Pos }

    Creates a copy of this attachment with the payload slot of T added/updated with the provided value.

    Creates a copy of this attachment with the payload slot of T added/updated with the provided value. Replaces an existing payload of the same type, if exists.

30. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

31. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

32. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

33. #### def →[B](y: B): (Attachments, B)

    Implicit information
      This member is added by an implicit conversion from Attachments to ArrowAssoc[Attachments] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Attachments to any2stringadd[Attachments]

### Inherited by implicit conversion StringFormat from Attachments to StringFormat[Attachments]

### Inherited by implicit conversion Ensuring from Attachments to Ensuring[Attachments]

### Inherited by implicit conversion ArrowAssoc from Attachments to ArrowAssoc[Attachments]

### Ungrouped